#######################EX6 - matriz de leslie - Luis Coelho ##########################

####dados#######
A <- rbind(c( 0.5000 , 1.0    , 0.75 ),
           c( 0.6666 , 0      ,    0 ),
           c(   0    , 0.3333 ,    0 ))
n0 <- matrix(c(20,0,0),ncol=1)
####teste multip matriz*vetor#####
A%*%n0

###########funo para clculo do tempo de estabilizao do crescimento da populao################
projmat=function(A,n0)
{
   mat<-A
   t<-1
   difprop<-1
   resulta<-matrix(n0,nrow=1) 
   if ( ( dim(A)[1]!=dim(A)[2] ) | (dim(A)[1]!=length(n0) )  ) 
   {
      stop ("Matriz de projeo e vetor da populao no tm dimenses compatveis")
   }
   while (t<=1000 & difprop > 0.00005)
   { 
      nt <- resulta[t,]
      ntplus <- A %*% nt
      Nt <- sum(nt)
      Ntplus <- sum(ntplus)
      difprop <- max(abs(ntplus/Ntplus)-(nt/Nt))
      resulta <- rbind(resulta,t(ntplus)) 
      t <- t+1
    }
    for (i in t:(t*2)) 
    { 
      nt <- resulta[i,]
      ntplus <- A %*% nt
      resulta <- rbind(resulta,t(ntplus))     
    }
    tempo=0:(dim(resulta)[1]-1)
    plot(tempo,resulta[,1],type="l",
    lwd=2,
    xlim=c(0,dim(resulta)[1]),
    ylim=c(0,max(resulta)),
    xlab="tempo",
    ylab="numero de individuos")
    for (i in 2:length(n0)) 
    {
      lines(tempo,resulta[,i],type="l", lty=i, col=i)
    }
    return(resulta)
}
projmat(A,n0)

######plotar grfico com estabilizao do valor de lambda no tempo############
proj1<-projmat(A,n0)
Nind=apply(proj1,1,sum)
Nprop=proj1/Nind
Nprop
lamb=Nind[2:length(Nind)]/Nind[1:(length(Nind)-1)]
plot(1:length(lamb), lamb, xlab="tempo", ylab = "lambda")

######clculo do valor reprodutivo##########
 auto.mat=function(A)
{
  auto <- eigen(A)
  auto.valor <- max(Re(auto$values))
  lamb0=round(auto.valor,4)
  vetor.direito <- Re(auto$vectors[,1])
  distr <-vetor.direito/sum(vetor.direito)
  diest0 <- round(distr,4)
  tmat <- t(A)
  autot=eigen(tmat)
  v <- Re(autot$vectors[,1])
  vr <- v/v[1]
  vr0=round(vr,4)
  return(list(lamb0,diest0,vr0))
}
auto.mat(A)
